using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.BLL
{
    /// <summary>
	/// T_Sys_TelTitleData
	/// </summary>
	public partial class T_Sys_TelTitleData
    {
        private readonly CallCenterApi.DAL.T_Sys_TelTitleData dal = new CallCenterApi.DAL.T_Sys_TelTitleData();
        public T_Sys_TelTitleData()
        { }
        #region  Method

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return dal.GetMaxId();
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            return dal.Exists(F_Id);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_TelTitleData model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_TelTitleData model)
        {
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            return dal.Delete(F_Id);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            return dal.DeleteList(F_Idlist);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_TelTitleData GetModel(int F_Id)
        {

            return dal.GetModel(F_Id);
        }

        /// <summary>
        /// 得到一个对象实体，从缓存中
        /// </summary>
        //public CallCenterApi.Model.T_Sys_TelTitleData GetModelByCache(int F_Id)
        //{

        //    string CacheKey = "T_Sys_TelTitleDataModel-" + F_Id;
        //    object objModel = Maticsoft.Common.DataCache.GetCache(CacheKey);
        //    if (objModel == null)
        //    {
        //        try
        //        {
        //            objModel = dal.GetModel(F_Id);
        //            if (objModel != null)
        //            {
        //                int ModelCache = Maticsoft.Common.ConfigHelper.GetConfigInt("ModelCache");
        //                Maticsoft.Common.DataCache.SetCache(CacheKey, objModel, DateTime.Now.AddMinutes(ModelCache), TimeSpan.Zero);
        //            }
        //        }
        //        catch { }
        //    }
        //    return (CallCenterApi.Model.T_Sys_TelTitleData)objModel;
        //}

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Sys_TelTitleData> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Sys_TelTitleData> DataTableToList(DataTable dt)
        {
            List<CallCenterApi.Model.T_Sys_TelTitleData> modelList = new List<CallCenterApi.Model.T_Sys_TelTitleData>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                CallCenterApi.Model.T_Sys_TelTitleData model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = new CallCenterApi.Model.T_Sys_TelTitleData();
                    if (dt.Rows[n]["F_Id"] != null && dt.Rows[n]["F_Id"].ToString() != "")
                    {
                        model.F_Id = int.Parse(dt.Rows[n]["F_Id"].ToString());
                    }
                    if (dt.Rows[n]["F_TitleName"] != null && dt.Rows[n]["F_TitleName"].ToString() != "")
                    {
                        model.F_TitleName = dt.Rows[n]["F_TitleName"].ToString();
                    }
                    if (dt.Rows[n]["F_KeyPhoneNum"] != null && dt.Rows[n]["F_KeyPhoneNum"].ToString() != "")
                    {
                        model.F_KeyPhoneNum = dt.Rows[n]["F_KeyPhoneNum"].ToString();
                    }
                    if (dt.Rows[n]["F_DefPhoneNumLen"] != null && dt.Rows[n]["F_DefPhoneNumLen"].ToString() != "")
                    {
                        model.F_DefPhoneNumLen = int.Parse(dt.Rows[n]["F_DefPhoneNumLen"].ToString());
                    }
                    if (dt.Rows[n]["F_WCode"] != null && dt.Rows[n]["F_WCode"].ToString() != "")
                    {
                        model.F_WCode = dt.Rows[n]["F_WCode"].ToString();
                    }
                    modelList.Add(model);
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        //public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        //{
        //return dal.GetList(PageSize,PageIndex,strWhere);
        //}

        #endregion  Method
    }
}
